
use TMInst;
use Cwd;


$NO_VALUE = TMInst::GetNoValue();


# CFGǂݍ
if(!open(IN, $ARGV[0])) {
	close(IN);
	exit();
}
@Temp = <IN>;
close(IN);

$i = 0;
$bank = 0;
foreach $_ (@Temp) {
	if($_ =~ /bank\s+(\d+)/) {	# bank
		$bank = $1;
	} elsif($_ =~ /drumset\s+(\d+)/) {	# drumset
		$bank = $1 + 128;
	}
	if($_ =~ /^\s*(\d+)\s+/) {	# @InstɃCXgDgi[
		$Inst[$bank][$1] = new TMInst($_);
		$Inst[$bank][$1]->SetBank($bank);
	} else {	# CXgDgłȂ@CFGɊi[
		$CFG[$i] = $_;
		$i++;
	}
}


# O[oϐ
$CURRENT_PATH = Cwd::getcwd();
$TIMIDITY_PATH = 'c:\\timidity_util\\timw32g.exe';
$TIMIDITY_OPTS = '-A70 -Ow';
$SOX_PATH = "rderr -- sox.exe output.wav temp.wav stat -v > temp.txt";


# ʏo
for($i=0;$i<256;$i++) {
	for($j=0;$j<128;$j++) {
		if($Inst[$i][$j]) {
			$temp_str = sprintf("tone/%03d/%03d%03d.mid",$i,$i,$j);
			$out = &GetVolume($temp_str);
			if($out != $NO_VALUE) {
				printf("%d,%d,%f\n",$i,$j,$out);
			}
		}
	}
}


# TiMidity++WAVo͂SOXő肵ĕԂ
sub GetVolume {
	my ($MID_PATH) = @_;
	my $sys = sprintf("%s %s %s",$TIMIDITY_PATH,$MID_PATH,$TIMIDITY_OPTS);
	system($sys);
	$sys = sprintf("%s",$SOX_PATH);
	system($sys);
	open(IN, "temp.txt");
	my @temp = <IN>;
	close(IN);
	if($temp[0] =~ /:/) {return $NO_VALUE;}
	else {return $temp[0];}
}
