
use TMInst;

$NO_VALUE = TMInst::GetNoValue();


# CFGǂݍ
if(!open(IN, $ARGV[0])) {
	close(IN);
	exit();
}
@Temp = <IN>;
close(IN);

$max_amp = 220;
$i = 0;
$bank = 0;
foreach $_ (@Temp) {
	if($_ =~ /bank\s+(\d+)/) {	# bank
		$bank = $1;
	} elsif($_ =~ /drumset\s+(\d+)/) {	# drumset
		$bank = $1 + 128;
	}
	if($_ =~ /^\s*(\d+)\s+/) {	# @InstɃCXgDgi[
		$Inst[$bank][$1] = new TMInst($_);
		$Inst[$bank][$1]->SetBank($bank);
		$amp = $Inst[$bank][$1]->GetAmp();
		if($amp != $NO_VALUE && $amp > $max_amp) {$max_amp = $amp;}
	} else {	# CXgDgłȂ@CFGɊi[
		$CFG[$i] = $_;
		$i++;
	}
}

# ʏo
$bank = 0;	# ̃oN͗LH
for($i=0;$i<256;$i++) {
	for($j=0;$j<128;$j++) {
		if($Inst[$i][$j]) {
			if($bank == 0) {
				if($i < 128) {printf("\nbank %d\n",$i);}
				else {printf("\ndrumset %d\n",$i-128);}
				$bank = 1;
			}
			if($Inst[$i][$j]->GetAmp() != $NO_VALUE) {
				$Inst[$i][$j]->SetAmp(log($Inst[$i][$j]->GetAmp() / $max_amp + 1.0) * $max_amp * 1.2);
			}
			$Inst[$i][$j]->Print();
		}
	}
	$bank = 0;
}
print "\n\n";


# foreach $_ (@CFG) {
# 	print $_;
# }
