
# TiMidity++ CXgDgW[
package TMInst;

# p[^Zbg̒libool^j
$NO_VALUE = -128;

# RXgN^
# <> $sLine: CXgDg̋Lq܂܂Cӂ̈s
sub new {
	my ($class_name,$sLine) = @_;	# 
	my ($this) = {};		# oϐpnbV
	bless ($this,$class_name);	# LnbVo^
	
	# oϐ
	$this->{bValid} = 0;		# ̃IuWFNg̃f[^͗LH
	$this->{sLine} = $sLine;	# ͑ΏۃC
	
	$this->{sComment} = $NO_VALUE;	# Rg
	$this->{sPath} = $NO_VALUE;	# pb`t@CpX
	$this->{bFont} = 0;		# TEhtHgH
	$this->{nBank} = $NO_VALUE;	# oN(128`255̓hZbg)
	$this->{nProg} = $NO_VALUE;	# vO(hZbgł̓m[g)
	$this->{nFontBank} = $NO_VALUE;	# TEhtHgoN
	$this->{nFontProg} = $NO_VALUE;	# TEhtHgvZbg
	$this->{nFontNote} = $NO_VALUE;	# TEhtHgL[m[g
	$this->{nAmp} = $NO_VALUE;	# amp=
	$this->{nPan} = $NO_VALUE;	# pan=
	$this->{nNote} = $NO_VALUE;	# note=
	$this->{bKeepLoop} = 0;		# keep=loop
	$this->{bKeepEnv} = 0;		# keep=env
	$this->{bStripLoop} = 0;	# strip=loop
	$this->{bStripEnv} = 0;		# strip=env
	$this->{bStripTail} = 0;	# strip=tail
	
	&ParseLine($this);	# sLine
		
	return $this;
}


# sLine͂AꂽoϐɊi[B
sub ParseLine {
	my ($this) = @_;	# 
		
	# vOԍ𓾂
	if($this->{sLine} =~ /^\s*(\d+)\s+/) {
		&SetProg($this,$1);
		&SetValid($this,1);
	} else {
		# ΃G[I
		&SetValid($this,0);
		return 1;
	}
	
	
	# TEhtHgł
	if($this->{sLine} =~ /%font/) {
		&SetFont($this,1);
		if($this->{sLine} =~ /^\s*\d+\s+%font\s+(\S+)\s+(\d+)\s+(\d+)/) {
			&SetPath($this,$1);
			&SetFontBank($this,$2);
			&SetFontProg($this,$3);
			if($this->{sLine} =~ /^\s*\d+\s+%font\s+\S+\s+\d+\s+\d+\s+(\d+)/) {
				&SetFontNote($this,$1);
			}
		} else {
			&SetValid($this,0);
			return 1;
		}
	} else {
		&SetFont($this,0);
		if($this->{sLine} =~ /^\s*\d+\s+(\S+)/) {
			&SetPath($this,$1);
		} else {
			&SetValid($this,0);
			return 1;
		}
	}
	
	# ʃIvV
	if($this->{sLine} =~ /amp=(\d+)/) {&SetAmp($this,$1);}
	if($this->{sLine} =~ /pan=(\S+)/) {&SetPan($this,$1);}
	if($this->{sLine} =~ /note=(\d+)/) {&SetNote($this,$1);}

	if($this->{sLine} =~ /keep=loop/) {&SetKeepLoop($this,1);}
	if($this->{sLine} =~ /keep=env/) {&SetKeepEnv($this,1);}
	if($this->{sLine} =~ /strip=loop/) {&SetStripLoop($this,1);}
	if($this->{sLine} =~ /strip=env/) {&SetStripEnv($this,1);}
	if($this->{sLine} =~ /strip=tail/) {&SetStripTail($this,1);}

	if($this->{sLine} =~ /\#(.*)/) {&SetComment($this,$1);}
}


# GetnTu[`
sub IsValid {
	my ($this) = @_;
	return $this->{bValid};
}

sub IsFont {
	my ($this) = @_;
	return $this->{bFont};
}

sub GetBank {
	my ($this) = @_;
	return $this->{nBank};
}

sub GetProg {
	my ($this) = @_;
	return $this->{nProg};
}

sub GetPath {
	my ($this) = @_;
	return $this->{sPath};
}

sub GetComment {
	my ($this) = @_;
	return $this->{sComment};
}

sub GetFontBank {
	my ($this) = @_;
	return $this->{nFontBank};
}

sub GetFontProg {
	my ($this) = @_;
	return $this->{nFontProg};
}

sub GetFontNote {
	my ($this) = @_;
	return $this->{nFontNote};
}

sub GetAmp {
	my ($this) = @_;
	return $this->{nAmp};
}

sub GetPan {
	my ($this) = @_;
	return $this->{nPan};
}

sub GetNote {
	my ($this) = @_;
	return $this->{nNote};
}

sub IsKeepLoop {
	my ($this) = @_;
	return $this->{bKeepLoop};
}

sub IsKeepEnv {
	my ($this) = @_;
	return $this->{bKeepEnv};
}

sub IsStripLoop {
	my ($this) = @_;
	return $this->{bStripLoop};
}

sub IsStripEnv {
	my ($this) = @_;
	return $this->{bStripEnv};
}

sub IsStripTail {
	my ($this) = @_;
	return $this->{bStripTail};
}

sub GetNoValue {
	my ($this) = @_;
	return $NO_VALUE;
}


# SetnTu[`
sub SetValid {
	my ($this,$bValid) = @_;	# 
	$this->{bValid} = $bValid;
}

sub SetFont {
	my ($this,$bFont) = @_;	# 
	$this->{bFont} = $bFont;
}

sub SetBank {
	my ($this,$nBank) = @_;	# 
	$this->{nBank} = $nBank;
}

sub SetProg {
	my ($this,$nProg) = @_;	# 
	$this->{nProg} = $nProg;
}

sub SetPath {
	my ($this,$sPath) = @_;	# 
	$this->{sPath} = $sPath;
}

sub SetComment {
	my ($this,$sComment) = @_;	# 
	$this->{sComment} = $sComment;
}

sub SetFontBank {
	my ($this,$nFontBank) = @_;	# 
	$this->{nFontBank} = $nFontBank;
}

sub SetFontProg {
	my ($this,$nFontProg) = @_;	# 
	$this->{nFontProg} = $nFontProg;
}

sub SetFontNote {
	my ($this,$nFontNote) = @_;	# 
	$this->{nFontNote} = $nFontNote;
}

sub SetAmp {
	my ($this,$nAmp) = @_;	# 
	if($nAmp > 800) {$nAmp = 800;}
	$this->{nAmp} = $nAmp;
}

sub SetPan {
	my ($this,$nPan) = @_;	# 
	$this->{nPan} = $nPan;
}

sub SetNote {
	my ($this,$nNote) = @_;	# 
	$this->{nNote} = $nNote;
}

sub SetKeepLoop {
	my ($this,$bKeepLoop) = @_;	# 
	$this->{bKeepLoop} = $bKeepLoop;
}

sub SetKeepEnv {
	my ($this,$bKeepEnv) = @_;	# 
	$this->{bKeepEnv} = $bKeepEnv;
}

sub SetStripLoop {
	my ($this,$bStripLoop) = @_;	# 
	$this->{bStripLoop} = $bStripLoop;
}

sub SetStripEnv {
	my ($this,$bStripEnv) = @_;	# 
	$this->{bStripEnv} = $bStripEnv;
}

sub SetStripTail {
	my ($this,$bStripTail) = @_;	# 
	$this->{bStripTail} = $bStripTail;
}


# o
sub Print {
	my ($this) = @_;	# 
	my $sOut;		# ꂪo͂
	
	# CXgDg񂪖ȂG[I	
	if(!&IsValid($this)) {return 1;}
	
	# o͂f[^𐶐
	$sOut = sprintf("%d",&GetProg($this));
	if(&IsFont($this)) {$sOut = sprintf("%s %%font",$sOut);}
	$sOut = sprintf("%s %s",$sOut,&GetPath($this));
	if(&GetFontBank($this) != $NO_VALUE) {
		$sOut = sprintf("%s %d",$sOut,&GetFontBank($this));
	}
	if(&GetFontProg($this) != $NO_VALUE) {
		$sOut = sprintf("%s %d",$sOut,&GetFontProg($this));
	}
	if(&GetFontNote($this) != $NO_VALUE) {
		$sOut = sprintf("%s %d",$sOut,&GetFontNote($this));
	}
	
	if(&GetAmp($this) != $NO_VALUE) {$sOut = sprintf("%s amp=%d",$sOut,&GetAmp($this));}
	if(&GetPan($this) != $NO_VALUE) {$sOut = sprintf("%s pan=%d",$sOut,&GetPan($this));}
	if(&GetNote($this) != $NO_VALUE) {$sOut = sprintf("%s note=%d",$sOut,&GetNote($this));}
	if(&IsKeepLoop($this)) {$sOut = sprintf("%s keep=loop",$sOut);}
	if(&IsKeepEnv($this)) {$sOut = sprintf("%s keep=env",$sOut);}
	if(&IsStripLoop($this)) {$sOut = sprintf("%s strip=loop",$sOut);}
	if(&IsStripEnv($this)) {$sOut = sprintf("%s strip=env",$sOut);}
	if(&IsStripTail($this)) {$sOut = sprintf("%s strip=tail",$sOut);}

	if(&GetComment($this) != $NO_VALUE) {$sOut = sprintf("%s\t#%s",$sOut,&GetComment($this));}
	
	$sOut = sprintf("%s\n",$sOut);	# sR[hǉ
	
	print $sOut;	# o
}

sub Get {
	my ($this) = @_;	# 
	my $sOut;		# ꂪo͂
	
	# CXgDg񂪖ȂG[I	
	if(!&IsValid($this)) {return 1;}
	
	# o͂f[^𐶐
	$sOut = sprintf("%d",&GetProg($this));
	if(&IsFont($this)) {$sOut = sprintf("%s %%font",$sOut);}
	$sOut = sprintf("%s %s",$sOut,&GetPath($this));
	if(&GetFontBank($this) != $NO_VALUE) {
		$sOut = sprintf("%s %d",$sOut,&GetFontBank($this));
	}
	if(&GetFontProg($this) != $NO_VALUE) {
		$sOut = sprintf("%s %d",$sOut,&GetFontProg($this));
	}
	if(&GetFontNote($this) != $NO_VALUE) {
		$sOut = sprintf("%s %d",$sOut,&GetFontNote($this));
	}
	
	if(&GetAmp($this) != $NO_VALUE) {$sOut = sprintf("%s amp=%d",$sOut,&GetAmp($this));}
	if(&GetPan($this) != $NO_VALUE) {$sOut = sprintf("%s pan=%d",$sOut,&GetPan($this));}
	if(&GetNote($this) != $NO_VALUE) {$sOut = sprintf("%s note=%d",$sOut,&GetNote($this));}
	if(&IsKeepLoop($this)) {$sOut = sprintf("%s keep=loop",$sOut);}
	if(&IsKeepEnv($this)) {$sOut = sprintf("%s keep=env",$sOut);}
	if(&IsStripLoop($this)) {$sOut = sprintf("%s strip=loop",$sOut);}
	if(&IsStripEnv($this)) {$sOut = sprintf("%s strip=env",$sOut);}
	if(&IsStripTail($this)) {$sOut = sprintf("%s strip=tail",$sOut);}

	if(&GetComment($this) != $NO_VALUE) {$sOut = sprintf("%s\t#%s",$sOut,&GetComment($this));}
	
	$sOut = sprintf("%s\n",$sOut);	# sR[hǉ
	
	return $sOut;	# o
}

# W[I[
1;

